;------------------------------------------------------------------------------------------------------	
		!to "fcycle3.prg"
;------------------------------------------------------------------------------------------------------
		!cpu 6510
;------------------------------------------------------------------------------------------------------
		*=  $0900
;------------------------------------------------------------------------------------------------------
;		Meta Settings
;------------------------------------------------------------------------------------------------------
		TAKE_BPL= 	1	;0: BPL ist not taken -> BMI will be used
					;1: BPL instrction is used
					
		MEM_MISALIGN=	0	;standard adress for loop code is $0b00
					;use MEM_MISALIGN to let code begin before page break
					;formula is CODE_ADRESS = $0b00 - MEM_MISALIGN
					;reasonable values are
					;+0: no page break
					;+1: page_break for both branch instructions
					;+4: page_break for BMI and BPL (if taken)
					;+5: page_break for BMI (if taken), for BPL !if not taken!
					;+6: page_break for BMI but not for BPL
					
		COND_CYCLE=	0	;cycle 0 is the first INC_cycle
					;adjust this value to slide the cycle where irq_cond occurs
;------------------------------------------------------------------------------------------------------
		CASE=		(1-TAKE_BPL)*$80
					;$00 -> BPL_taken
					;$80 -> BPL_not_taken, BMI_taken
					
		BASE=		$0b00 - 18 - MEM_MISALIGN
					
		ADR=		BASE+COND_CYCLE
;------------------------------------------------------------------------------------------------------
init_irq	
		sei
		lda #$35
		sta $01
		
		jsr set_timer
		
		lda #$00		;reset screen_pointer for timer_values
		sta screen_off+1
		
		lda #$7f		;init irq
		sta $d01a
		sta $dc0d
		lda #$81
		sta $d01a
		lda #<irq
		ldx #>irq
		sta $fffe
		stx $ffff
		
		lda #$1b		;this routine makes sure that the irq is not called directly
					;after the cli
		sta $d011
		ldx #$21
		cpx $d012
		bne *-3
		dex
		stx $d012
		dec $d019
		lda $dc0d
		dec $01			;irq will be called in plain ram environment ($01=$34)
		cli

		jmp *			;main_routine is of no further interest here
;------------------------------------------------------------------------------------------------------
irq		
		inc $01			;stabilizing the raster with the timer_method
		sta $fc
		lda $dc04
		eor #$0f
		lsr
		sta .branch+1
		bcc *+2
.branch		bpl *
		nop
		nop
		nop
		nop
		nop
		stx $fd
		sty $fe
		
		lda #<irq2		;preparing the second irq
		ldx #>irq2
		sta $fffe
		stx $ffff
		lda #$22
		sta $d012
		ldx #4			
		dex
		bne *-1
		dec $d019		;irq2 must occur within this irq - just like double_irq
		cli
					;from this point it will take 29 cycles to reach the 1st
					;cycle of rasterline 22,where the ras_irq will occur
					
		lda #CASE		;this sets $c000 so we always have the same situation for the
					;branch_instructions
		sta $c000
		jmp ADR			;continuing at ADR,where the chosen amount of cycles is killed
					;it is followed by our test_code, the INC_BPL_BMI_loop
;------------------------------------------------------------------------------------------------------
irq2		
		lda $dc04		;this is the second irq - it reads the timer and prints it to
					;the screen
		;clc
		;adc #$20
		nop
		eor #$27
screen_off	sta $0400		;the read values lie between $17 and $10
		inc screen_off+1
		
		pla			;this is the usual double_irq_fix, as we want to get back to
					;the main_routine
		pla
		pla
		lda #<irq
		ldx #>irq
		sta $fffe
		stx $ffff
		lda #$20
		sta $d012
irq_end		
		dec $d019
		dec $01
		lda $fc
		ldx $fd
		ldy $fe
		rti
;------------------------------------------------------------------------------------------------------
		*=  $09c0
;------------------------------------------------------------------------------------------------------
set_timer				;timer init routine
		ldx #$3e
		
		lda $d012
		bne *-3
		
		stx $dc04
		sta $dc05
		ldx #$11
var_kill	
		ldy #$08
		dey
		bpl *-1
		
		cmp $d012
		;---------------;
		beq *+2
		
		lda $cf13,y
		cmp #$07
		bne var_kill
		
		ldy #$03
		dey
		bne *-1
		nop
		
		stx $dc0e
		rts
;------------------------------------------------------------------------------------------------------
		*=  BASE
;------------------------------------------------------------------------------------------------------
		lda #$a9		;this is a wellknown sequence to get rid of a chosen number of
		lda #$a9		;cycles - used here to define the exact irq_cond-cycle
		lda #$a9		
		lda #$a9
		lda #$a9
		lda #$a9
		lda #$a9
		lda #$a9
		bit $ea
		
loop		inc $c000,x		;the code loop for testing
		bpl loop		;depending on BASE (or MEM_MISALIGN resp.), it's possible to 
		bmi loop		;check the behaviour of page_breaking branch_instructions		
;------------------------------------------------------------------------------------------------------
